v_macro code
	expand

	; Copy bit srcb from register srcf to dstf, dstb.
copybit	macro srcf, srcb, dstf, dstb
	btfsc srcf, srcb
	bsf dstf, dstb
	btfss srcf, srcb
	bcf dstf, dstb
	endm

	; Read one byte from eeprom and return it in W
eeprom_read macro addr
	banksel EEADR
	movlw addr
	movwf EEADR
	
	banksel EECON1
	bcf EECON1, EEPGD
	bsf EECON1, RD
	
	banksel EEDAT
	movf EEDAT, W
	endm

	; Write one byte from W to eeprom
	; Interrupts must be disabled
eeprom_write macro addr
	banksel EEADR
	movwf EEDAT
	movlw addr
	movwf EEADR
	
	banksel EECON1
	bcf EECON1, EEPGD
	bsf EECON1, WREN
	
; 	Required sequence start
	movlw 0x55
	movwf EECON2
	movlw 0xAA
	movwf EECON2
	bsf EECON1, WR
; 	Required sequence end
	
	btfsc EECON1, WR
	goto $-1
	
	bcf EECON1, WREN
	endm


