	include p16f689.inc
	include macros.inc

d_rnd	udata_shr
rndgen	res 2
rndtmp	res 1

v_rnd	code

	; Load seed from eeprom
load_seed
	eeprom_read 0
	movwf rndgen
	eeprom_read 1
	movwf rndgen+1
	return

store_seed
	movf rndgen, W
	eeprom_write 0
	movf rndgen+1, W
	eeprom_write 1
	return

rnd_iter
	clrc
	rlf rndgen, F
	rlf rndgen + 1, F
	
	btfss STATUS, C
	return
	
	movlw 0x11
	xorwf rndgen, F
	movlw 0x93
	xorwf rndgen + 1, F
	
	return

rnd_mod	macro
	movlw 0x03
	andwf rndgen + 1, W
	endm

	; Do random iteration and return number between 0 and 3 in W.
rnd_get
	call load_seed
	
	rnd_mod
	movwf rndtmp

loop	; Don't select same number twice
	call rnd_iter
	
	rnd_mod
	xorwf rndtmp, W
	btfsc STATUS, Z
	goto loop
	
	call store_seed
	
	rnd_mod
	return

	global rnd_get
	end
